/*  $Id: a.out-plan9.hh,v 1.1 1999/06/01 15:44:32 shaggy Exp $
 */

#ifndef ASM

typedef unsigned int uint;
#include <vstream>
#include <vdir>

// note:  a.out support, in this format, is nearly non-existent
// right now.  This is being provided for now so that the SOLO
// bootloader can recognize the a.out format (using the offsets 
// generated from this file), but this C++ class is currently unused.

#define _MAGIC(b)	((((4*b)+0)*b)+7)

class a_out_plan9 {
public:
	typedef unsigned char	uchar;
	typedef unsigned short	ushort;
	typedef unsigned long	ulong;

// main file header:

	struct exec {
		long magic;		// magic number
		long text;		// size of text segment
		long data;		// size of initialized data
		long bss;		// size of uninitialized data
		long syms;		// size of symbol table
		long entry;		// initial execution address
		long spsz;		// size of pc/sp offset table
		long pcsz;		// size of pc/line number table
	};

	enum a_magic {
		A_MAGIC = _MAGIC(8),	// 68020
		I_MAGIC = _MAGIC(11),	// intel 386
		J_MAGIC = _MAGIC(12),	// intel 960
		K_MAGIC = _MAGIC(13),	// sparc
		V_MAGIC = _MAGIC(16),	// mips 3000
		X_MAGIC = _MAGIC(17),	// att dsp 3210
		M_MAGIC = _MAGIC(18),	// mips 4000
		D_MAGIC = _MAGIC(19),	// amd 29000
		E_MAGIC = _MAGIC(20),	// arm 7-something
		Q_MAGIC = _MAGIC(21),	// powerpc
		N_MAGIC = _MAGIC(22),	// mips 4000 LE
		L_MAGIC = _MAGIC(23)
	};

	struct sym {
		long	value;
		char	type;
		char	*name;
	};

private:
	exec hdr;
	vstream *stream;	// current file
public:
	a_out_plan9(vstream *stream);
	~a_out_plan9();
};


#else

#include "a.out-plan9.ofs"
#include <endian.h>

#endif 


