/*  $Id: srt0.S,v 1.9 1999/06/20 01:27:21 shaggy Exp $
 *      Standalone RunTime for C/C++ programs
 *      relative path: ./lib/boot/m-pc
 */ 

#include <boot/bootparam.h>

#ifdef __ELF__
#	define C(x)	x
#else
#	define C(x) _##x
#endif


// note about stacks:
//	if 'initial_stack_top' is non-zero, then this is used for
//	the stack top, otherwise, 'initial_stack_size' bytes are reserved.
 

.text

// NOTE: (this applies to all assembly code)
//   C functions on the 386 will automatically save all registers
//   used except eax, ecx, and edx


.globl _start
//	start code for kernel; called from SOLO 
//	in:	ebx = address of BootParam structure
//	out:	eax = exit value
//		and other registers in unknown states
_start:
	movl	%ebx,C(bootparam)
	movb	$1,C(_bootparam_initialized)
	movl	C(initial_stack_top),%eax
	or	%eax,%eax
	jnz	1f	
	mov	BootParam__himem(%ebx),%eax
	mov	C(initial_stack_size),%edx
	sub	%edx,BootParam__himem(%ebx)	// adjust himem
1: 	
	mov	%eax,%esp

	call	__do_global_ctors
	movl	C(bootparam),%ebx
	movl	BootParam__envp(%ebx),%eax
	movl	%eax,C(environ)
	pushl	%eax
	pushl	BootParam__argv(%ebx)
	pushl	BootParam__argc(%ebx)
	call	C(main)
	addl	$12,%esp

	pushl	%eax
	call	__do_global_dtors
	popl	%eax

	movl	C(bootparam),%ebx
	pushl	%eax
	jmp	*BootParam__exit(%ebx)


// BootParam *bootparam
.globl C(bootparam)
C(bootparam):
	.long	0

// bool _bootparam_initialized:
.globl C(_bootparam_initialized)
C(_bootparam_initialized):	
	.byte	0


// bool _bootparam_init()
.globl C(_bootparam_init)
C(_bootparam_init):
	movb	C(_bootparam_initialized),%al
	ret


// char **environ;
.globl C(environ)
C(environ):
	.long	0

// just stubbing these for now, to keep gcc happy:
.globl C(abort)
C(abort):
	ret
.globl C(__write)
C(__write):
	ret
.globl C(_exit)
C(_exit):
	ret


#ifndef __ELF__
.globl ___main		// for a.out format
___main:
	ret
#endif


