/*  $Id: Error.hh,v 1.4 1999/07/16 20:18:48 shaggy Exp $
 *      relative path: ./lib/c++
 */ 

#ifndef __Error_hh__
#define __Error_hh__

class Error {
protected:
	const char *name;
	const char *func;
public:
	const char* get_name() const { return name; }
	const char* get_func() const { return func; }
	Error(const char *s) { name = s; }
	virtual char* msg(char *buf) const;
	Error& at(const char *f) { func = f; return *this; }
};


void unexpected(const Error &e) __attribute__((noreturn));


/* IDEA:
	See tj for error stack details
 */

#ifdef HANDLE_EXCEPTIONS
#pragma Make Flags_Needed += -fhandle-exceptions
#define	THROW(e)	throw e
#define	TRY_BEGIN	try {
#define TRY_END		}
#define CATCH(o)	catch(o)
#define CATCH_ALL	catch(...)

#else 

#ifdef __dynamic__
// XXX -- must change THROW to actually return an error
#define THROW(e)	{ unexpected(e.at(__PRETTY_FUNCTION__)); }
#define TRY_BEGIN	
#define TRY_END
#define CATCH(o)	if(0)
#define CATCH_ALL

// #define TRY_BEGIN	{ obj _result_;
// #define TRY_END		} catch_block:
// #define CATCH(o)	if(_result_.istype(o)) 
// #define CATCH_ALL	
// #define OBJCALL(f)	if(Error((_result_ = f))) goto catch_block;

#else
#define THROW(e)	{ unexpected(e.at(__PRETTY_FUNCTION__)); }
#define TRY_BEGIN	
#define TRY_END
#define CATCH(o)	if(0)
#define CATCH_ALL
#endif
#endif

#ifdef ideas

TRY_BEGIN
	x
	OBJCALL(y)
	z
TRY_END
CATCH(a) {
	stuff
}
CATCH_ALL {
	morestuff
}

becomes:

try {
	x
	y (ocall)
	z
}
catch(a) {
	stuff
}
catch(...) {
	morestuff
}

or:

	obj result;
	x
	if(fail(result = y)) 
		goto catch_block
	z	
catch_block:
	if(result_matches(a)) {
		stuff
	}
	{
		morestuff
	}
#endif

#endif
