/*  $Id: packed.hh,v 1.4 1999/07/16 20:18:48 shaggy Exp $
 *      relative path: ./lib/c++
 */

#ifndef __packed_hh__
#define __packed_hh__

// XXX - This code ought to be temporary, but
// for now, GCC 2.7.2 is broken and doesn't correctly support
// __attribute__((packed)), and so these data types must be
// substituted in structures that need a smaller alignment than
// the default.

// Actually, other compilers might not support the equivalent
// of __attribute__((packed)), so this might be a good idea to try
// to write all code that depends on packing using these routines,
// to increase portability.  (will this technique work on all systems?)


template <class T> class packed {
        uchar b[sizeof(T)];
public:
        T& operator=(T n)
                { *(T*)b = n; return *(T*)b; }
        operator T() const { return *(T*)b; }
};


inline template class packed<uint8>;	// redundant and unnecessary
inline template class packed<uint16>;
inline template class packed<uint32>;
inline template class packed<uint64>;
inline template class packed<int8>;	// redundant, unnecessary, 
					// and repetitive
inline template class packed<int16>;
inline template class packed<int32>;
inline template class packed<int64>;

#endif
