/*  $Id: vdir.hh,v 1.4 1999/07/16 20:18:48 shaggy Exp $
 *      relative path: ./lib/c++
 */

#ifndef __vdir_hh__
#define __vdir_hh__


#include <stdx1.h>
#include <vobject>
#include <vfile>

class vdirstream;
class vstream;
class vstat;


const class_t class_vdir = 0x00022000;


class vdir : public vobject {
public:
	virtual bool is_a(class_t c) const
		{ return (c == class_vdir) || vobject::is_a(c); }
	virtual vdirstream* opendir() const = 0;
	virtual bool _mkdir(const char *name) const;
	virtual const vobject* _get_object(const char *name) const;
	virtual const vfile* _get_file(const char *name) const;
	virtual const vdir* _get_dir(const char *name) const;
	virtual bool _stat(const char *name, vstat *vs) const;
	virtual vstream* _open(const char *name,
				int flags = vstream::READ) const;
	virtual vdirstream* _opendir(const char *name) const;
	virtual bool mkdir(const char *dname) const;
	virtual const vobject* get_object(const char *fname,
					const char *path = 0) const;
	virtual const vfile* get_file(const char *fname,
				      const char *path = 0) const;
	virtual const vdir* get_dir(const char *fname,
				      const char *path = 0) const;
	virtual bool stat(const char *fname, vstat *vs) const;
	virtual vstream* open(const char *fname, 
				int flags = vstream::READ) const;
	virtual vdirstream* opendir(const char *fname) const;
	virtual const vdir* dup() const = 0;
};


#endif
