/*  $Id: vdirstream.hh,v 1.6 2000/01/11 07:32:38 shaggy Exp $
 *      relative path: ./lib/c++
 */

#ifndef __vdirstream_hh__
#define __vdirstream_hh__

#ifndef _POSIX_SOURCE
# define _POSIX_SOURCE
#endif

#include <stdx1.h>
#include <sys/types.h>


class vobject;

class vdirent {
protected:
	const char *name;
public:
	const char* get_name() const { return name; }
	virtual const vobject* get_object() const;
	virtual int compare(const char *name) const;
	bool match(const char *name) const
		{ return !compare(name); }
	virtual const vdirent* dup() const = 0;
};


class vdirstream {
protected:
	const vdirent *ent;
public:
	virtual ~vdirstream() {}
	virtual const vdirent* read() = 0;
	virtual off_t tell() const = 0;
	virtual void seek(off_t ofs) = 0;
	void rewind() { seek(0); }
	const char* get_name() const { return ent->get_name(); }
	int compare(const char *name) const { return ent->compare(name); }
	bool match(const char *name) const { return ent->match(name); }
	const vobject* get_object() const { return ent->get_object(); }
	virtual vdirstream* dup() const;
};

#endif
