/*  $Id: 8742kb.h,v 1.3 1999/06/20 01:27:28 shaggy Exp $
 *	8042/8741/8742 KeyBoard controller
 *      relative path: ./lib/hw
 */

#define KB_OUTPUT		0x0	// Read 
#define KB_INPUT		0x0	// Write 
#define	KB_CTRL			0x4	// Write 
#define KB_STATUS		0x4	// Read 
#define KB_SIZEOF		0x8	// ???

#define 	KB_STATUS_OUT_RDY	0x01	// data in output buffer
#define 	KB_STATUS_IN_RDY	0x02	// data in output buffer
#define 	KB_STATUS_SELFTEST	0x04	// self test okay
#define 	KB_STATUS_CMD		0x08	// command written via 0x64
#define		KB_STATUS_KBFREE	0x10	// not locked
#define		KB_STATUS_AUX		0x20	// output buffer from aux
#define		KB_STATUS_TIMEOUT	0x40	// general timeout
#define		KB_STATUS_PARITY	0x80	// parity error


#define KB_CTRL_AUX_DISABLE	0xa7	// disable auxiliary device 
#define KB_CTRL_AUX_ENABLE	0xa8	// enable auxiliary device 
#define KB_CTRL_CHECK_AUX	0xa9	// check interface to auxiliary device
#define KB_CTRL_READ_INPUT	0xc0	// transfers input port into output buffer
#define KB_CTRL_READOUT_LOW	0xc1	// repeatedly read 0-3 into status 4-7 
#define KB_CTRL_READOUT_HIGH	0xc2	// repeatedly read 4-7 into status 4-7 
#define KB_CTRL_READ_OUTPUT	0xd0	// transfers output port into output buffer 
#define KB_CTRL_WRITE_OUTPUT	0xd1	// write next byte into output port 
#define KB_CTRL_WRITE_OUTBUF	0xd2	// write next byte into output buffer 
#define KB_CTRL_WRITE_AUX	0xd3	// write aux device output buffer 
#define KB_CTRL_PULSE_RESET	0xfe	// pulse the system reset line 

// also need:	0xaa, 0xab, 0xad, 0xae, 0xc0, 0xc1, 0xc2, 0xd0, 0xd1, 0xd2, 0xd3, 0xd4
//		0xe0, 0xf0-0xff 


#define KB_CMD_LED		0xed	// turn on/off LED's
#define 	KB_LED_SCRL	0x01 	// scroll lock LED
#define 	KB_LED_NUML	0x02 	// num lock LED
#define 	KB_LED_CAPS	0x04 	// caps lock LED
#define KB_CMD_ECHO		0xee	// send back 0xee
#define KB_CMD_SETSCAN		0xf0	// set scan code set and get present set
#define KB_CMD_ID		0xf2	// return keyboard ID
#define KB_CMD_SETRATE		0xf3	// set repitition rate and delay
#define		KB_RATE_250MS	0x00	// 250 ms delay
#define		KB_RATE_500MS	0x20	// 500 ms delay
#define		KB_RATE_750MS	0x40	// 750 ms delay
#define		KB_RATE_1000MS	0x60	// 1000 ms delay
#define		KB_RATE_30CPS	0x00	// 30 chars/sec
#define		KB_RATE_11CPS	0x0b	// 11 chars/sec
#define		KB_RATE_2CPS	0x1f	// 2 chars/sec
#define KB_CMD_ENABLE		0xf4	// enable keyboard
#define KB_CMD_STAND_DIS	0xf5	// sets standard values and disables KB
#define KB_CMD_STAND_DIS2	0xf6	// alternative STAND_DIS command
#define KB_CMD_RESEND		0xfe	// retransmit last character
#define KB_CMD_RESET		0xff	// execute an internal keyboard reset


#define KB_INPUT_KBLOCK		0x80
#define KB_INPUT_MONO		0x40
#define KB_INPUT_AUXD		0x02
#define KB_INPUT_KBDI		0x01

#define KB_OUTPUT_KBDO		0x80
#define	KB_OUTPUT_KCLK		0x40
#define KB_OUTPUT_AUXB		0x20
#define KB_OUTPUT_OUTB		0x10
#define KB_OUTPUT_ACLK		0x08
#define KB_OUTPUT_AXDO		0x04
#define KB_OUTPUT_GA20		0x02
#define KB_OUTPUT_SYSR		0x01
#define KB_OUTPUT_A20_ON	0xdf
#define KB_OUTPUT_A20_OFF	0xdd

#define KB_ACK			0xfa	
#define	KB_OVERFLOW		0x00
#define	KB_KEYERR		0xff
#define KB_BAT_COMPLETE		0xaa
#define KB_BAT_ERROR		0xfc
#define KB_RESEND		0xfe

