/* $Id: keyboard.h,v 1.3 1999/06/01 05:42:45 shaggy Exp $
 */

// a few standard keys:

#define KEY_BS		0x08	// backspace (ctrl-H)
#define KEY_LF		0x0a	// linefeed (ctrl-J)
#define KEY_NL		0x0a	// newline (ctrl-J)
#define KEY_CR		0x0d	// carriage return (ctrl-M)
#define KEY_DEL		0x7f	// delete (ctrl-/ or ctrl-backspace)
#define KEY_ESC		0x1b	// escape (ctrl-[)
#define KEY_EOF		0x04	// end of file (ctrl-D)
#define KEY_TAB		0x09	// tab (ctrl-I)	
#define KEY_SPACE	0x20	// space
#define KEY_XOFF	0x13	// stop trasmit (ctrl-S)
#define KEY_XON		0x11	// start trasmit (ctrl-Q)
#define KEY_INTR	0x03	// interrupt (ctrl-c)
#define KEY_BELL	0x07	// bell/alarm (ctrl-g)
#define KEY_SUSP	0x1a	// suspend (ctrl-z)


// non-standard keys return the scancode with the high bit set,
// so the following codes can be used to access some of them:

#define KEY_UP		0xc8	// cursor up
#define KEY_DOWN	0xd0	// cursor down
#define KEY_LEFT	0xcb	// cursor left
#define KEY_RIGHT	0xcd	// cursor right
#define KEY_DELETE	0xd3	// keypad delete
#define KEY_INSERT	0xd2	// keypad insert
#define KEY_PGUP	0xc9	// page up
#define KEY_PGDN	0xd1	// page down
#define KEY_HOME	0xc7	// keypad home
#define KEY_END		0xcf	// keypad end
#define KEY_BREAK	0x80	// ctrl-break

#define KEY_F1		0xbb	// function key F1
#define KEY_F2		0xbc	// function key F2
#define KEY_F3		0xbd	// function key F3
#define KEY_F4		0xbe	// function key F4
#define KEY_F5		0xbf	// function key F5
#define KEY_F6		0xc0	// function key F6
#define KEY_F7		0xc1	// function key F7
#define KEY_F8		0xc2	// function key F8
#define KEY_F9		0xc3	// function key F9
#define KEY_F10		0xc4	// function key F10

