/*  $Id: ArgParse.cc,v 1.3 2000/01/12 03:44:47 shaggy Exp $
 *      relative path: sys/boot
 *  
 *  Copyright (c) 1995 Frank E. Barrus.  All rights reserved.
 *  
 *  This file is part of the ShagOS distribution, and may be freely used and
 *  distributed by the terms of the ShagWare General Public License (SGPL),
 *  version 2, or, at your option, any newer official version of that License.
 *  
 *  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
 *  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND,
 *  INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 *  FITNESS FOR A PARTICULAR PURPOSE, AND WILL NOT BE LIABLE FOR ANY DAMAGES.
 *  For more warranty details, see the ShagWare General Public License, which
 *  should have been received with this program, in a file called 'lic_spl2.txt'
 *  If this license is missing, please contact the author and describe how
 *  this software was obtained.  Email: shaggy@csh.rit.edu
 *  
 *  Complete, unaltered, original distributions of this and related code
 *  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
 *  or:	ftp://ftp.csh.rit.edu/pub/members/shaggy
 */

#pragma Make Includes_Banned += -nostdinc -nostdinc++

#include <libc.h>
#include <stdx1.h>
#include <new.h>
#include "smstring.hh"

#include "ArgParse.h"

bool
ArgParse::match(csz *s, bool *set)
{
	if(_num < _argc) {
		if(!strcmp(s, _argv[_num])) {
			_num++;
			if(set)
				*set = true;
			return true;
		}
	} else
		missing();
	return false;
}


bool
ArgParse::match(csz *s, string *str)
{
	if(match(s)) 
		return get(str);
	return false;
}


bool
ArgParse::prefix(csz *s, bool *set)
{
	if(_num < _argc) {
		if(!strncmp(s, _argv[_num], strlen(s))) {
			_num++;
			if(set)
				*set = true;
			return true;
		}
	} else
		missing();
	return false;
}


bool
ArgParse::prefix(csz *s, string *str)
{
	if(prefix(s)) { 
		if(_argv[_num-1][strlen(s)-1]) {
			*str = &_argv[_num-1][strlen(s)-1];
		} else
			return get(str);
	}
	return false;
}


bool
ArgParse::flag(char f, bool *)
{
	return false;
}


bool
ArgParse::get(string *str)
{
	if(_num < _argc) {
		*str = _argv[_num++];
		return true;
	} else 
		missing();
	return false;
}


void
ArgParse::badoption()
{
	fprintf(stderr, "bad option: %s\n", _argv[_num-1]);
	if(_quit)
		exit(1);
}

void
ArgParse::badflag()
{
}


void
ArgParse::missing()
{
	fprintf(stderr, "missing argument after %s\n", _argv[_num-1]);
	if(_quit)
		exit(1);
}

