/* $Id: dump.c,v 1.2 1999/07/16 20:18:51 shaggy Exp $
 */

#include <stdio.h>
#include <stdx1.h>

static void
dump_file(FILE *f)
{
	byte buf[16];
	int n, i;
	int offset = 0;

	while((n = fread(buf, 1, sizeof(buf), f)) > 0) {
		printf("%08x: ", offset);
		for(i=0; i<sizeof(buf); i++)
			if(i < n)
				printf("%02x ", buf[i]);
			else
				printf("   ");
		printf(" ");
		for(i=0; i<n; i++)
			if(buf[i] < 32)
				printf(".");
			else
				printf("%c", buf[i]);
		printf("\n");		
		offset += n;
	}
}

int
main(int argc, csz **argv)
{
	int i = 0;
	FILE *f;

	if(argc == 1)
		dump_file(stdin);
	while(++i < argc) {
		if(!strcmp(argv[i], "-"))
			dump_file(stdin);
		else if(!(f = fopen(argv[i], "r"))) 
			perror(argv[i]);
		else {
			dump_file(f);
			fclose(f);
		}
	}
	return 0;
}

