#include <stdx1.h>

struct diskinfo {
	int biosid;		/* BIOS ID for device */
	int devid;		/* current OS ID for device */
	uint cyls, heads, secs;	/* total CHS values for device */
	ulong tsecs;	/* total linear sectors */
	uint secsize;	/* sector size for device, in bytes */
	uint maxmult;	/* max# of sectors that can be read at once */
	ulong start;	/* offset to first sector (for partitions) */
};

struct diskmap {
	uint blocksize;		/* current block size, in bytes */
	size_t size;		/* total file/device size in bytes */
	off_t pos;		/* current position being used */
	uint cyl, head, sec;	/* CHS for sector at current pos */
	ulong linear;	/* linear sector number at current pos */
	uint nsec;	/* number of contiguous sectors */
	uint ofs;	/* byte offset into first sector */
	uint len;	/* count of contiguous bytes */
};


extern_C_begin

int devname(dev_t dev, sz *devname);
int diskinfo(int fd, struct diskinfo *di);
int diskmap(int fd, struct diskinfo *di, struct diskmap *dm);

extern_C_end

